require_relative 'box_drawing_chars'

module SoPerf
  class ColorHelper
    include BoxDrawingChars
    @@use_color = true

    def self.use_color(bool=true)
      @@use_color = bool
    end

    def self.use_color?
      @@use_color
    end

    def self.reset_color_index
      @@color_index = -1
    end

    def self.pick_a_color
      colors        = [:cyan, :green, :red, :yellow, :magenta, :light_blue, :light_green, :light_red, :light_yellow]
      @@color_index ||= -1
      @@color_index += 1
      @@color_index =0 if @@color_index>colors.length-1
      colors[@@color_index]
    end

    def self.colorize(str, color)
      if @@use_color
        str.gsub(
            TICK_CHAR, ColorHelper.color(TICK_CHAR, color)).gsub(
            TICK_ON_LINE_CHAR, ColorHelper.color(TICK_ON_LINE_CHAR, color)).gsub(
            TICK_ON_LINE_START_CHAR, ColorHelper.color(TICK_ON_LINE_START_CHAR, color)).gsub(
            TICK_ON_LINE_END_CHAR, ColorHelper.color(TICK_ON_LINE_END_CHAR, color)).gsub(
            SINGLE_SPACE_LINE, ColorHelper.color(SINGLE_SPACE_LINE, color))
      end
    end

    def self.color(str, color)
      if @@use_color
        case color
          when :cyan
            str.cyan
          when :green
            str.green
          when :red
            str.red
          when :yellow
            str.yellow
          when :magenta
            str.magenta
          when :light_blue
            str.light_blue
          when :light_green
            str.light_green
          when :light_red
            str.light_red
          when :light_yellow
            str.light_yellow
          else
            str
        end
      else
        str
      end
    end
  end
end
