require_relative 'box_drawing_chars'

module SoPerf

  class Spacer
    def initialize(chars=0)
      chars   = chars.length if chars.is_a?(String)
      @length = chars
    end

    def space(i=0)
      i      = i.length if i.is_a?(String)
      spacer = ''
      (@length-i).times { spacer<<' ' }
      spacer
    end
  end

  module TerminalHelper
    def terminal_width
      `/usr/bin/env tput cols`.to_i
    end
  end

  module ValueFinder
    def closest(arr, val) #returns the index of the closest-matching element of the array
      closest = arr.map { |elem| (elem-val).abs }
      closest.index(closest.min)
    end
  end

  module TimeHelper
    def translate_time(val)
      val = val.abs.round(2)
      if val == 0
        0
      else
        res = val
        if res/1000.0 >= 1
          res = res/1000.0 #to seconds
          if res/60.0 >= 1
            res = res/60.0
            if res/60.0 >= 1
              res = res/60.0
              if res/24 >= 1
                res = res/24
                format(res, "d")
              else
                format(res, "h")
              end
            else
              format(res, "m")
            end
          else
            format(res, "s")
          end
        else
          format(res, "ms")
        end
      end
    end

    def format(res, unit)
      "#{res.round(2).to_s.gsub(/\.0$/, '')}#{unit}"
    end
  end
end
